%% example script

clear all
close all

%% load data

% The example data consists of three X-blocks 
% with 20,100 and 1000 variables, and 3 
% response variables.

load example_data.mat

%% Run PO-PLS 

X={X1 X2 X3};

options=POSO_PLS(X,Y)
options.preprocX{1}='autoscale'; %the first block is autoscaled
options.autoselect=1;

model=POSO_PLS(X,Y,options)
model=crossval_POSO_PLS(model,'r20')
plotoptions=plot_POSO_PLS
plot_POSO_PLS(model,plotoptions)

%CV-ANOVA table Y1
model.ANOVA.table{1}

%% Run SO-PLS 
close all;

options=POSO_PLS(X,Y)
options.preprocX{1}='autoscale'; %the first block is autoscaled
options.blockCombinations={1 2 3}; %no common contributions --> SO-PLS
options.autoselect=1;

model=POSO_PLS(X,Y,options)
model=crossval_POSO_PLS(model,'r20')
plotoptions=plot_POSO_PLS(model)
plot_POSO_PLS(model,plotoptions)

%CV-ANOVA table Y1
model.ANOVA.table{1}


