function [Yhat,That] = mypredict(X,model,A)
% [Yhat,That] = mypredict(X,model,A)
%
% OUTPUT
% Yhat    Predicted values with A components
%
% INPUT
% X       Descriptor data, saisir structure
% model   Model struct
% A       Optional. Number of model components to use for prediction.
%         Default is one set of predictions for each component
%
% Created: 22/10 2008
% Modified: 28/10 2008
% Status:  testing
%
% Ingrid Mge

[n,p]=size(X.d);

% if p~=size(model.B,1) % m endres i forhold til inertactions/squares
%     error('Number of X-variables does not match model')
% end

if nargin==2
    A=1:size(model.T,2);
end

%calcualte interactions and polynomials
if isfield(model.X,'modelmatrix')
    %autoscale
    %X.d=(X.d-repmat(mean(model.X.d(:,1:model.X.modelmatrix.Numb_of_vars)),n,1))./repmat(std(model.X.d(:,1:model.X.modelmatrix.Numb_of_vars)),n,1);
    X=model_matrix(X,model);
end


%initialize Yhat
Yhat=zeros(n,size(model.Y.d,2),length(A));

%Preprocess X
X.d=(X.d-repmat(model.Xpp.mean,n,1))./repmat(model.Xpp.std,n,1);

%Predict
for i=1:length(A)
    Yhat(:,:,i) = (X.d*model.B(:,:,A(i))).*repmat(model.Ypp.std,n,1)+repmat(model.Ypp.mean,n,1);
end

That=X.d*model.W(:,1:max(A))*inv(model.P(:,1:max(A))'*model.W(:,1:max(A)));


