function X=mypreprocess(X,method)
% X=mypreprocess(X,method)
%
% method is a string, either 'mean center' or 'autoscale'

if isempty(method)
    X.pp.meth='No preprocessing';
    X.pp.mean=zeros(1,size(X.d,2));
    X.pp.std=ones(1,size(X.d,2));
else


        if isequal(lower(method),'auto scale')
            method='autoscale';
        end
        switch lower(method)

            case 'mean center'
                if isfield(X,'pp')
                    if isequal(lower(X.pp.meth),'autoscale') | isequal(lower(X.pp.meth),'mean center')
                        error('Data set is alreay centered!')
                    end
                end
                Xm=mean(X.d);
                Xs=ones(1,size(X.d,2));
                X.d=(X.d-repmat(Xm,size(X.d,1),1))./repmat(Xs,size(X.d,1),1);
                X.pp.meth=method;
                X.pp.mean=Xm;
                X.pp.std=Xs;


            case 'autoscale'
                if isfield(X,'pp')
                    if isequal(lower(X.pp.meth),'autoscale')
                        error('Data set is alreay autoscaled!')
                    end
                end
                Xm=mean(X.d);
                Xs=std(X.d);
                X.d=(X.d-repmat(Xm,size(X.d,1),1))./repmat(Xs,size(X.d,1),1);
                X.pp.meth=method;
                X.pp.mean=Xm;
                X.pp.std=Xs;
            otherwise
                if ~isfield(X,'pp')
                    X.pp.meth='No preprocessing';
                    X.pp.mean=zeros(1,size(X.d,2));
                    X.pp.std=ones(1,size(X.d,2));
                end
        end
end