function H=sample_grouping(x,y,groupvar,ilab,col)
% sample_grouping(x,y,groupvar,ilab,col)
% 
% x,y         Data points to plot
% groupvar    grouping variable, can be char or numerical
% ilab        labels for data points
% col         optional. 64 x 3 matrix with colors



N=unique(groupvar,'rows');
Ngroups=size(N,1);
if Ngroups>64
    Ngroups=64;
end


if Ngroups==64 % max number of different colors
   %divide "groupvar" into 64 segments
   limits=linspace(min(groupvar),max(groupvar),Ngroups);
   groupvar2=[];
   for i=1:length(limits)-1
       idx=find(groupvar>=limits(i) & groupvar<limits(i+1));
       groupvar2(idx)=i;
   end
   idx=find(groupvar>=limits(end));
   groupvar2(idx)=64;
 
   groupvar2=groupvar2';
   N=unique(groupvar2,'rows');
   Ngroups=length(N);
   
else
    groupvar2=groupvar;
end
    

xrange=max(x)-min(x);
H=gcf;
if Ngroups>7
    if ~exist('col','var')
col=colormap(jet);
    end

%col=col(1:50,:);
colidx=round(linspace(1,size(col,1),Ngroups));
col=col(colidx,:);
else
    col=colormap(lines);
    %col(1:3,:)=col([3 1 2],:);
    %col(2,:)=[162 205 90]/255; %for plotting grains
end
hold on;
for i=1:Ngroups
    idx=[];
    for j=1:length(x)
        if isequal(groupvar2(j,:),N(i,:))
            idx=[idx; j];
        end
    end

    h=plot(x(idx),y(idx),'.');
    set(h,'color',col(i,:));
    h=text(x(idx)+xrange/100,y(idx),ilab(idx,:));
    set(h,'color',col(i,:));
end

if size(N,1)<10
legend(num2str(N),'Location','NorthWest');
else
    H=colorbar;
    idx=linspace(min(groupvar),max(groupvar),64);
    set(H,'YTickLabel',idx(get(H,'YTick')));
end
    
